<template>
  <div class="fr-table fr-table--bordered fr-table--no-caption fr-mb-0">
    <table>
      <caption>
        Historique des changements
      </caption>
      <thead>
        <tr>
          <th scope="col">Date</th>
          <th scope="col">Auteur</th>
          <th scope="col">Action</th>
          <th
            v-if="!routeWithParams"
            scope="col"
          >
            Attribut
          </th>
          <th
            v-if="routeWithParams"
            scope="col"
          >
            Élément
          </th>
        </tr>
      </thead>
      <tfoot v-if="shownRevisionsNb && shownRevisionsNb < revisions.length">
        <td colspan="100%">
          <button
            class="fr-btn fr-btn--secondary see-all-btn"
            @click="shownRevisionsNb = null"
          >
            Tout voir
          </button>
        </td>
      </tfoot>
      <tbody>
        <tr
          v-for="revision in displayedRevisions"
          :key="revision.id"
        >
          <td>{{ formatDate(revision.timestamp, 'DD/MM/YYYY HH:mm') }}</td>
          <td>
            {{ revision.author }}
          </td>
          <td>{{ ACTION_LABELS.get(revision.action) }}</td>
          <td v-if="revision.property">{{ revision.property }}</td>
          <td v-if="routeWithParams">
            <NuxtLink
              v-if="revision.itemUrl"
              :to="revision.itemUrl"
              class="fr-link"
              target="_self"
            >
              Voir la fiche
            </NuxtLink>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script setup>
  import { READONLY_FIELDS, formatDate } from '~/utils'
  import {
    ACTION_LABELS,
    CREATE_ACTION,
    UPDATE_ACTION
  } from '~/utils/constants/history'

  const DEFAULT_SHOWN_REVISIONS_NB = 5

  const props = defineProps({
    history: { type: Array, required: true },
    /**
     * Used for the history of a collection
     * It defines the URL base to access the item within the application
     */
    routeWithParams: { type: Function, default: null }
  })

  const shownRevisionsNb = ref(DEFAULT_SHOWN_REVISIONS_NB)

  const revisions = computed(() => {
    const revisions = props.history.reduce((revisions, activity) => {
      const revisionBase = {
        timestamp: activity.timestamp,
        author: activity.user
          ? `${activity.user.first_name} ${activity.user.last_name}`
          : '(inconnu)',
        action: activity.action
      }
      const activityRevisions = []

      if (activity.action === UPDATE_ACTION) {
        Object.entries(activity.revisions[0].delta).forEach(([key]) => {
          if (READONLY_FIELDS.includes(key)) return
          activityRevisions.push({
            ...revisionBase,
            id: `${activity.id}-${key}`,
            property: key
          })
        })
      } else {
        const revision = {
          ...revisionBase,
          id: `${activity.id}`,
          item: activity.item
        }
        if (activity.action === CREATE_ACTION && props.routeWithParams) {
          revision.itemUrl = `${props.routeWithParams(activity.item)}`
        }
        activityRevisions.push(revision)
      }

      return [...revisions, ...activityRevisions]
    }, [])

    return revisions
  })

  const displayedRevisions = computed(() => {
    return shownRevisionsNb.value
      ? revisions.value.slice(0, shownRevisionsNb.value)
      : revisions.value
  })
</script>

<style scoped>
  .fr-table > table {
    display: table;
  }

  .see-all-btn {
    display: block;
    margin: 0 auto;
  }
</style>
